Attribute VB_Name = "FTDI"
Public FT_HANDLE As Long, buff(65536) As Byte

' FT_ListDevices Flags

Public Const FT_LIST_NUMBER_ONLY As Long = &H80000000
Public Const FT_LIST_BY_INDEX As Long = &H40000000
Public Const FT_LIST_ALL As Long = &H20000000

' FT_Open

Public Const FT_OPEN_BY_SERIAL_NUMBER As Long = 1
Public Const FT_OPEN_BY_DESCRIPTION As Long = 2

' FT_STATUS

Public Const FT_OK As Long = 0
Public Const FT_INVALID_HANDLE As Long = 1
Public Const FT_DEVICE_NOT_FOUND As Long = 2
Public Const FT_DEVICE_NOT_OPENED As Long = 3
Public Const FT_IO_ERROR As Long = 4
Public Const FT_INSUFFICIENT_RESOURCES As Long = 5
Public Const FT_INVALID_PARAMETER As Long = 6
Public Const FT_INVALID_BAUD_RATE As Long = 7
Public Const FT_DEVICE_NOT_OPENED_FOR_ERASE As Long = 8
Public Const FT_DEVICE_NOT_OPENED_FOR_WRITE As Long = 9
Public Const FT_FAILED_TO_WRITE_DEVICE As Long = 10
Public Const FT_EEPROM_READ_FAILED As Long = 11
Public Const FT_EEPROM_WRITE_FAILED As Long = 12
Public Const FT_EEPROM_ERASE_FAILED As Long = 13
Public Const FT_EEPROM_NOT_PRESENT As Long = 14
Public Const FT_EEPROM_NOT_PROGRAMMED As Long = 15
Public Const FT_INVALID_ARGS As Long = 16
Public Const FT_OTHER_ERROR As Long = 17
 
Public Const GENERIC_READ As Long = &H80000000
Public Const GENERIC_WRITE As Long = &H40000000
Public Const OPEN_EXISTING As Long = 3
Public Const FILE_ATTRIBUTE_NORMAL As Long = &H80
Public Const FILE_FLAG_OVERLAPPED As Long = &H40000000
Public Const INVALID_HANDLE_VALUE As Long = -1

' FTDI DLL Bindings

Public Declare Function FT_ListDevices Lib "FTD2XX.DLL" (ByVal pvArg1 As Long, ByVal pvArg2 As Long, ByVal dwFlags As Long) As Long
Public Declare Function FT_W32_CreateFile Lib "FTD2XX.DLL" (ByVal lpszName As String, ByVal dwAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreate As Long, ByVal dwAttrsAndFlags As Long, ByVal hTemplate As Long) As Long
Public Declare Function FT_W32_CloseHandle Lib "FTD2XX.DLL" (ByVal ftHandle As Long) As Boolean
Public Declare Function FT_W32_WriteFile Lib "FTD2XX.DLL" (ByVal ftHandle As Long, ByVal lpBuffer As Long, ByVal dwBytesToWrite As Long, ByVal lpdwBytesWritten As Long, ByVal LPOVERLAPPED As Long) As Boolean
Public Declare Function FT_W32_ReadFile Lib "FTD2XX.DLL" (ByVal ftHandle As Long, ByVal lpBuffer As Long, ByVal dwBytesToRead As Long, ByVal lpdwBytesReturned As Long, ByVal LPOVERLAPPED As Long) As Boolean
Public Declare Function FT_W32_GetOverlappedResult Lib "FTD2XX.DLL" (ByVal ftHandle As Long, ByVal LPOVERLAPPED As Long, ByVal lpdwBytesTransferred As Long, ByVal bWait As Boolean) As Boolean
Public Declare Function FT_GetStatus Lib "FTD2XX.DLL" (ByVal ftHandle As Long, ByVal lpdwAmountInRxQueue As Long, ByVal lpdwAmountInTxQueue As Long, ByVal lpdwEventStatus As Long) As Long
Public Declare Function FT_Read Lib "FTD2XX.DLL" (ByVal ftHandle As Long, ByVal lpBuffer As Long, ByVal dwBytesToRead As Long, ByVal lpdwBytesReturned As Long) As Long
Public Declare Function FT_ResetDevice Lib "FTD2XX.DLL" (ByVal ftHandle As Long) As Long


Public Type FT_OVERLAPPED
    Internal As Long
    InternalHigh As Long
    Offset As Long
    OffsetHigh As Long
    hEvent As Long
End Type


Public FT_Op


Public Function FT_WriteByte(handle As Long, mybyte As Byte) As Long
    Dim bytes_written As Long
    Dim buff(1) As Byte
    buff(0) = mybyte

    Call FT_W32_WriteFile(handle, VarPtr(buff(0)), 1, VarPtr(bytes_written), 0)
    FT_WriteByte = bytes_written
End Function


Public Function FT_ReadByte(handle As Long, buff As Byte) As Long
    Dim bytes_read As Long

    Call FT_W32_ReadFile(handle, VarPtr(buff), 1, VarPtr(bytes_read), 0)
    FT_ReadByte = bytes_read
End Function


Public Function FT_Open(description As String) As Long
    FT_Open = FT_W32_CreateFile(description, GENERIC_READ Or GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL Or FT_OPEN_BY_DESCRIPTION, 0)
End Function


Public Function FT_OpenSerial(serial As String) As Long
    FT_OpenSerial = FT_W32_CreateFile(serial, GENERIC_READ Or GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL Or FT_OPEN_BY_SERIAL_NUMBER, 0)
End Function


Public Function FT_CloseHandle(ByRef handle As Long) As Boolean
    FT_CloseHandle = FT_W32_CloseHandle(handle)
    handle = 0
End Function


Public Function FT_GetDeviceCount()
    Dim devices As Long
    Dim ft_status As Long
    
    ft_status = FT_ListDevices(VarPtr(devices), 0, FT_LIST_NUMBER_ONLY)
    If ft_status = FT_OK Then FT_GetDeviceCount = devices Else FT_GetDeviceCount = 0
    
End Function


Public Function FT_GetDeviceDescription(device As Long) As String
    Dim ft_status As Long
    Dim buffer(64) As Byte
    Dim n As Byte
    Dim ASCII As Byte
    Dim desc As String
    
    ft_status = FT_ListDevices(device, VarPtr(buffer(0)), FT_LIST_BY_INDEX Or FT_OPEN_BY_DESCRIPTION)

    If ft_status = FT_OK Then
        For n = 0 To 63
            ASCII = buffer(n)
            If ASCII = 0 Then Exit For
            desc = desc + Chr(ASCII)
        Next n
        FT_GetDeviceDescription = desc
    Else
        FT_GetDeviceDescription = ""
    End If

End Function


Public Function FT_GetDeviceSerialNumber(device As Long) As String
    Dim ft_status As Long
    Dim buffer(16) As Byte
    Dim n As Byte
    Dim ASCII As Byte
    Dim serial As String
    
    ft_status = FT_ListDevices(device, VarPtr(buffer(0)), FT_LIST_BY_INDEX Or FT_OPEN_BY_SERIAL_NUMBER)
    
    If ft_status = FT_OK Then
        For n = 0 To 15
            ASCII = buffer(n)
            If ASCII = 0 Then Exit For
            serial = serial + Chr(ASCII)
        Next n
        FT_GetDeviceSerialNumber = serial
    Else
        FT_GetDeviceSerialNumber = ""
    End If

End Function


